## garmin 196 functions
var last_time = 0.0;
var last_bearing = -1;

var init_variables = func{
	##tests
	props.globals.getNode("/instrumentation/garmin196/wp/wp[1]/visible",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/wp/wp[1]/type",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/wp/wp[1]/x",1).setDoubleValue(-0.01);
	props.globals.getNode("/instrumentation/garmin196/wp/wp[1]/y",1).setDoubleValue(-0.01);
	props.globals.getNode("/instrumentation/garmin196/wp/wp[1]/id",1).setValue("TEST1");
	
	##init waypoint system
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-id",1).setValue("-----");
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-dto-id",1).setValue("-----");
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-bearing",1).setDoubleValue(0);
	props.globals.getNode("/instrumentation/garmin196/position-wpt-bearing",1).setDoubleValue(0);

	##init map system
	props.globals.getNode("/instrumentation/garmin196/map-range",1).setDoubleValue(0.125);
	
	##init saveable variables
	props.globals.getNode("/instrumentation/garmin196/antenne-deg",1).setDoubleValue(30);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(30);
	props.globals.getNode("/instrumentation/garmin196/max-speed",1).setDoubleValue(175);
	props.globals.getNode("/instrumentation/garmin196/symbols/airport",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/vor",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/ndb",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/fix",1).setBoolValue(1);
	
	props.globals.getNode("/instrumentation/garmin196/version",1).setValue("JeeP v. 20/01/2012 0");
	
	##status du gps
	#0 eteint
	#1 startup page
	#1x map page
	#2x panel page
	#3x position page
	props.globals.getNode("/instrumentation/garmin196/status",1).setDoubleValue(0);
	
	##popup windows
	#0 = pas de popup
	#1 = affichage du reglage de la lumiere
	props.globals.getNode("/instrumentation/garmin196/popup_status",1).setBoolValue(0);
	
	props.globals.getNode("/instrumentation/garmin196/serviceable",1).setBoolValue(0);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(0);
	
	main_loop();
}
setlistener("/sim/signals/fdm-initialized",init_variables,0,0);

var load_parameters = func{
	fgcommand("loadxml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", targetnode: "/instrumentation/garmin196/save" }));
	
	if(getprop("/instrumentation/garmin196/save/antenne-deg")!=nil){
		setprop("/instrumentation/garmin196/antenne-deg",getprop("/instrumentation/garmin196/save/antenne-deg"));
	}
	if(getprop("/instrumentation/garmin196/save/light")!=nil){
		setprop("/instrumentation/garmin196/light",getprop("/instrumentation/garmin196/save/light"));
	}
	if(getprop("/instrumentation/garmin196/save/max-speed")!=nil){
		setprop("/instrumentation/garmin196/max-speed",getprop("/instrumentation/garmin196/save/max-speed"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/airport")!=nil){
		setprop("/instrumentation/garmin196/symbols/airport",getprop("/instrumentation/garmin196/save/symbols/airport"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/vor")!=nil){
		setprop("/instrumentation/garmin196/symbols/vor",getprop("/instrumentation/garmin196/save/symbols/vor"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/ndb")!=nil){
		setprop("/instrumentation/garmin196/symbols/ndb",getprop("/instrumentation/garmin196/save/symbols/ndb"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/fix")!=nil){
		setprop("/instrumentation/garmin196/symbols/fix",getprop("/instrumentation/garmin196/save/symbols/fix"));
	}
	
	
}
setlistener("/sim/signals/fdm-initialized",load_parameters);

var save_parameters = func{
		##preparation
		if(getprop("/instrumentation/garmin196/antenne-deg")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/antenne-deg",1).setDoubleValue(getprop("/instrumentation/garmin196/antenne-deg"));
		}
		if(getprop("/instrumentation/garmin196/light")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/light",1).setDoubleValue(getprop("/instrumentation/garmin196/light"));
		}
		if(getprop("/instrumentation/garmin196/max-speed")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/max-speed",1).setDoubleValue(getprop("/instrumentation/garmin196/max-speed"));
		}
		props.globals.getNode("/instrumentation/garmin196/save/symbols/airport",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/airport"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/vor",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/vor"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/ndb",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/ndb"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/fix",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/fix"));
		fgcommand("savexml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", sourcenode: "/instrumentation/garmin196/save" }));
}

var main_loop = func{
	var time = getprop("/sim/time/elapsed-sec");
    var dt = time - last_time;
    last_time = time;
	
	calcul_turn_rate(dt);
	change_speed_display();
	change_position_wpt_bug();
	
	settimer(main_loop, 0.3);
}

var nyi = func (x) { gui.popupTip(x ~ ": not yet implemented", 3); }

var power = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(x==0){
		if(serviceable==1){
			setprop("/instrumentation/garmin196/serviceable",0);
			setprop("/instrumentation/garmin196/status",0);
			setprop("/instrumentation/garmin196/popup_status",0);
		}else{
			setprop("/instrumentation/garmin196/serviceable",1);
			setprop("/instrumentation/garmin196/status",1);
		}
	}
	
	if(x==1 and serviceable==1){
		setprop("/instrumentation/garmin196/popup_status",1)
	}

}

var in = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				var range = getprop("/instrumentation/garmin196/map-range");
				range = range / 2;
				if(range<0.125){
					range = 0.125;
				}
				setprop("/instrumentation/garmin196/map-range",range);
				return;
			}
		}
	}
}

var out = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				var range = getprop("/instrumentation/garmin196/map-range");
				range = range * 2;
				if(range>8){
					range = 8;
				}
				setprop("/instrumentation/garmin196/map-range",range);
				return;
			}
		}
	}
}

var page = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/status",20);
				return;
			}
			
			if(status==20){
				setprop("/instrumentation/garmin196/status",30);
				return;
			}
			
			if(status==30){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
		}
	}
}

var quit = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				save_parameters();
				return;
			}
			
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/status",30);
				return;
			}
			
			if(status==20){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
			
			if(status==30){
				setprop("/instrumentation/garmin196/status",20);
				return;
			}
		}
	}
}

var enter = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				save_parameters();
				return;
			}
			
			##validation de la startup page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==1){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
		}
	}
}

var menu = func (x){
	nyi("menu");
}

var nrst = func (x){
	nyi("nrst");
}

var dto = func (x){
	nyi("dto");
}

var rockerup = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level + 0.1;
				if(light_level>1){
					light_level = 1;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
			
			##deplacement de la map page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/test-z",getprop("/instrumentation/garmin196/test-z")+0.0001);
				return;
			}
		}
	}
}

var rockerdown = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level - 0.1;
				if(light_level<0){
					light_level = 0;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
			
			##deplacement de la map page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/test-z",getprop("/instrumentation/garmin196/test-z")-0.0001);
				return;
			}
		}
	}
}

var rockerleft = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##deplacement de la map page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/test-y",getprop("/instrumentation/garmin196/test-y")-0.0001);
				return;
			}
		}
	}
}

var rockerright = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##deplacement de la map page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/test-y",getprop("/instrumentation/garmin196/test-y")+0.0001);
				return;
			}
		}
	}
}

##recalc speed to display
var change_speed_display = func{
	var max_speed = getprop("/instrumentation/garmin196/max-speed");
	var speed = getprop("/instrumentation/gps/indicated-ground-speed-kt");
	setprop("/instrumentation/garmin196/speed-display",315*speed/max_speed);
}

##calcul du turn rate
var calcul_turn_rate = func(dt){
	if(last_bearing==-1){
		last_bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	}
	bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	
	var turn_rate = abs(bearing - last_bearing);
	if(turn_rate>180){
		turn_rate = 360 - turn_rate;
 	}
	var sgn = 1;
	if(bearing - last_bearing<0){
		sgn = -1;
	}
	turn_rate = turn_rate/dt;
	if(turn_rate<10){##pour enlever les valeurs aberentes
		props.globals.getNode("/instrumentation/garmin196/turn-rate",1).setDoubleValue(sgn*turn_rate);
	}
	last_bearing = bearing;
}

var change_wpt_id = func{
	if(getprop("/instrument/gps/mode")!=nil and getprop("/autopilot/route-manager/wp[0]/id")!=""){
		props.global.getNode("/instrumentation/garmin196/panel-wpt-id").alias("/autopilot/route-manager/wp[0]/id");
	}else{
		setprop("/instrumentation/garmin196/panel-wpt-id",getprop("/instrumentation/garmin196/panel-wpt-dto-id"));
	}
}
setlistener("/instrumentation/gps/mode",change_wpt_id);

var change_position_wpt_bug = func{
	var wpt_bearing = getprop("/instrumentation/gps/wp/wp[1]/bearing-mag-deg");
	var aircraft_bearing = getprop("/instrumentation/gps/indicated-track-magnetic-deg");
	
	var diff = wpt_bearing - aircraft_bearing;
	setprop("/instrumentation/garmin196/position-wpt-bearing",diff);
	setprop("/instrumentation/garmin196/panel-wpt-bearing",diff);
}

var update_map = func{
	var max_plots = 25;
	var offset_mul = 0.034;
	var symbol_map_range = getprop("/instrumentation/garmin196/map-range") * 8;
	var plots = [];
	var type_symbol = [ "airport" , "vor" , "ndb" , "fix" ];
	
	for(var i=0;i<size(type_symbol);i=i+1){
		if(getprop("/instrumentation/garmin196/symbols/"~type_symbol[i])==1){
			props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(max_plots + 1);
			props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
			props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
			setprop("/instrumentation/gps/scratch/type", type_symbol[i]);
			setprop("/instrumentation/gps/command", "nearest");
			
			while (getprop('/instrumentation/gps/scratch/has-next')) {
				var id = getprop('/instrumentation/gps/scratch/ident');
				var range = getprop('/instrumentation/gps/scratch/distance-nm') / symbol_map_range; 
				var bearing = 360 - getprop("/instrumentation/gps/indicated-track-magnetic-deg") + getprop('/instrumentation/gps/scratch/mag-bearing-deg');
				#var bearing = 360 - getprop("/orientation/heading-deg") + getprop('/instrumentation/gps/scratch/mag-bearing-deg');
				if(bearing<0){
					bearing = bearing + 360;
				}
				
				if(bearing>360){
					bearing = bearing - 360;
				}
				
				if(i==1){##vor
					id = id ~ " " ~ sprintf("%2.2f",getprop('/instrumentation/gps/scratch/frequency-mhz'));
				}
				
				if(i==2){##ndb
					id = id ~ " " ~ sprintf("%2.1f",getprop('/instrumentation/gps/scratch/frequency-khz'));
				}
				
				var plot = { id: id,bearing: bearing,type: i,range: range};
				if(range<=1){
					append(plots,plot);
				}else{
					break;
				}
				setprop("/instrumentation/gps/command", "next");
			}
		}
	}

	var plots_sorted = sort (plots, func (a,b) a.range - b.range);
	var nb_plots = max_plots;
	if(nb_plots>size(plots_sorted)){
		nb_plots = size(plots_sorted);
	}
	for(var i=0;i<nb_plots;i=i+1){
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/id",1).setValue(plots_sorted[i].id);
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/type",1).setValue(plots_sorted[i].type);
		
		##calcul des coordonnees
		var x_wp = math.cos(plots_sorted[i].bearing*math.pi/180) * plots_sorted[i].range * offset_mul;
		var y_wp = math.sin(plots_sorted[i].bearing*math.pi/180) * plots_sorted[i].range * offset_mul;
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/x",1).setDoubleValue(x_wp);
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/y",1).setDoubleValue(y_wp);
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/brg_offset",1).setDoubleValue(plots_sorted[i].bearing);
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/norm_dist",1).setDoubleValue(plots_sorted[i].range);
		#
		if(x_wp<0.026 and x_wp>-0.026 and y_wp<0.0323 and y_wp>-0.0323){##si on est dans l'ecran, on affiche
			props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/visible",1).setBoolValue(1);
		}else{
			props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/visible",1).setBoolValue(0);
		}
	}

	for(var i=nb_plots;i<max_plots;i=i+1){
		props.globals.getNode("/instrumentation/garmin196/wp/wp["~i~"]/visible",1).setIntValue(0);
	}
	
	if(getprop("/instrumentation/garmin196/serviceable")==1 and getprop("/instrumentation/garmin196/status")==10){
		settimer(update_map,1);
	}
}


















